﻿Public Class Form1
    Private Sub ButOPEN_Click(sender As Object, e As EventArgs) Handles ButOPEN.Click
        Dim ofd As OpenFileDialog = New OpenFileDialog()
        ofd.Filter = "Images(*.bmp *.tif *.tiff *.gif)|*.bmp;*.tif;*.tiff; *.gif|Tutti i file (*.*)|*.*"
        ofd.RestoreDirectory = True
        If ofd.ShowDialog() = DialogResult.OK Then
            Me.Text = ofd.FileName
            Dim immagine As Bitmap = New Bitmap(ofd.FileName) ' in immagine l'immagine scelta
            Dim palette As Imaging.ColorPalette = immagine.Palette ' in palette, la palette dell'immagine scelta
            If palette.Entries.Length = 0 Then
                LabINFO.Text = immagine.Width & "x" & immagine.Height & " " & immagine.PixelFormat.ToString & ", L' immagine non ha una palette"
            Else
                LabINFO.Text = immagine.Width & "x" & immagine.Height & " " & immagine.PixelFormat.ToString & ", L' immagine ha una palette da " & palette.Entries.Length & " colori"
            End If
            Dim imgPalette As New Bitmap(320, 320) ' una bitmap per disegnare la palette
            Dim g As Graphics = Graphics.FromImage(imgPalette) ' g = layer grafico di disegno
            Dim riga As Integer
            Dim colonna As Integer
            ListBox1.Items.Clear()
            For i = 0 To palette.Entries.Length - 1
                riga = Math.Truncate(i / 16) * 20 ' calcolo della riga corrente
                colonna = (i Mod 16) * 20 ' calcolo della colonna corrente
                ' Disegno un quadratino alle coordinate calcolate con il colore della palette, largo/alto 19 pix
                g.FillRectangle(New SolidBrush(palette.Entries(i)), colonna, riga, 19, 19)
                ListBox1.Items.Add("Valore: " & i.ToString("000") & "; RGB associato = " & palette.Entries(i).R.ToString("000") & ", " & palette.Entries(i).G.ToString("000") & ", " & palette.Entries(i).B.ToString("000"))
            Next i
            ' mostro l'immagine della palette disegnata, in una picturebox
            PictureBox1.BackgroundImage = imgPalette
            ' mostro l'immagine che contiene la palette disegnata, in una picturebox
            PictureBox2.BackgroundImage = New Bitmap(ofd.FileName)
            immagine.Dispose()
            ofd.Dispose()
        End If
    End Sub
End Class
